/* Created with BASH BaCon 2.4.0 - (c) Peter van Eerten - GPL v3 */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/utsname.h>
#include <dirent.h>
#include <setjmp.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <signal.h>
#include <search.h>
#include <ftw.h>
#include <regex.h>
#include <fcntl.h>
static jmp_buf __b2c__jump;
static int __b2c__trap = 0;
static int __b2c__catch_set_backup, __b2c__catch_set = 0;
static int ERROR = 0;
static int __b2c__option_compare = 0;
static int __b2c__option_memstream = 0;
static int __b2c__option_startpoint = 0;
static int __b2c__option_open = O_RDWR | O_NOCTTY | O_SYNC;
#define __b2c__MEMTYPE char
static int __b2c__collapse = 0;
int __b2c__break_ctr = 0;
int __b2c__break_flag = 0;
int RETVAL = 0;
int REGLEN = 0;
struct timeval __b2c__tm;
time_t __b2c__elapsed_secs;
int __b2c__elapsed_usecs;
struct itimerval __b2c__alarm;
char __b2c__chop_default[] = "\r\n\t ";
char VERSION__b2c__string_var[] = "2.4.0";

/* User include files */
/* READ/DATA include files */
int __b2c__stringarray_ptr = 0, __b2c__stringarray_ctr = 0;
#include "picscale.bac.string.h"
int __b2c__floatarray_ptr = 0, __b2c__floatarray_ctr = 0;
#include "picscale.bac.float.h"
int __b2c__ctr;

/* Math functions */
extern double round (double __b2c__x);
extern long int lrint (double __b2c__x);
#include <math.h>
#define SQR(__b2c__x) sqrt((double)__b2c__x)
#define POW(__b2c__x, __b2c__y) pow((double)__b2c__x, (double)__b2c__y)
#define SIN(__b2c__x) sin((double)__b2c__x)
#define COS(__b2c__x) cos((double)__b2c__x)
#define TAN(__b2c__x) tan((double)__b2c__x)
#define ASIN(__b2c__x) asin((double)__b2c__x)
#define ACOS(__b2c__x) acos((double)__b2c__x)
#define ATN(__b2c__x) atan((double)__b2c__x)
#define LOG(__b2c__x) log((double)__b2c__x)
#define EXP(__b2c__x) exp((double)__b2c__x)
#define SGN(__b2c__x) ((__b2c__x) == 0 ? 0 : ((__b2c__x) < 0 ? -1 : 1))
#define ROUND(__b2c__x) lrint((double)__b2c__x)
#define INT(__b2c__x) lrint((double)__b2c__x)
#define MOD(__b2c__x, __b2c__y) ((long)(__b2c__x) % (long)(__b2c__y))
#define EVEN(__b2c__x) (((long)(__b2c__x) % 2 == 0) ? 1 : 0)
#define ODD(__b2c__x) (((long)(__b2c__x) % 2 != 0) ? 1 : 0)
#define FLOOR(__b2c__x) (long)floor(__b2c__x)
#undef ABS
#define ABS(__b2c__x) (((__b2c__x) < 0) ? -(__b2c__x) : (__b2c__x))
#define RND random()
#define MAXRANDOM RAND_MAX
#define RANDOM(__b2c__x) ((__b2c__x) != 0 ? random()/(MAXRANDOM/(__b2c__x)) : 0)

/* Other functions */
#define VAL(__b2c__x) ((__b2c__x) != NULL ? atof(__b2c__x) : 0)

/* Unix functions */
#include <unistd.h>
#define SYSTEM(__b2c__x) do {if (__b2c__x != NULL) {RETVAL = system(__b2c__x); if(WIFEXITED(RETVAL)) RETVAL = WEXITSTATUS(RETVAL);} else RETVAL=0;} while(0)

/* String functions */
#include <string.h>
char __b2c__input__buffer[512];
char *__b2c__sbuffer[256] = { NULL };
long __b2c__sbuffer_length[256] = { 0 };

int __b2c__sbuffer_ptr = 0;
char *__b2c__rbuffer[32] = { NULL };
long __b2c__rbuffer_length[32] = { 0 };

int __b2c__rbuffer_ptr = 0;
static jmp_buf __b2c__gosub_buffer[32] = { 0 };

int __b2c__gosub_buffer_ptr = -1;
char **__b2c__deltree = { NULL };

int __b2c__del_ctr = 0;
/* Temporary pointer to perform assignments */
char *__b2c__assign = NULL;
char *__b2c__split = NULL;
char *__b2c__split_tmp = NULL;
char *ERR__b2c__string_var (int);
#define RUNTIMEERROR(__b2c__a, __b2c__x, __b2c__y, __b2c__z) do {fprintf(stderr, "Runtime error: statement '%s' at line %d in '%s': %s\n", __b2c__a, __b2c__x, __b2c__y, ERR__b2c__string_var(__b2c__z)); exit(__b2c__z);} while(0)
#define RUNTIMEFERR(__b2c__a, __b2c__x, __b2c__y, __b2c__z) do {fprintf(stderr, "Runtime error: function '%s': %s\n", __b2c__y, ERR__b2c__string_var(__b2c__z)); exit(__b2c__z);} while(0)
void *
__rbuf_realloc (void *__b2c__ptr, size_t __b2c__size)
{
  if (__b2c__rbuffer_length[__b2c__rbuffer_ptr] < __b2c__size)
    {
      __b2c__rbuffer_length[__b2c__rbuffer_ptr] = (long) __b2c__size *4;
      return (realloc (__b2c__ptr, __b2c__size * 4));
    }
  return (__b2c__ptr);
}

void *
__sbuf_realloc (void *__b2c__ptr, size_t __b2c__size)
{
  if (__b2c__sbuffer_length[__b2c__sbuffer_ptr] < __b2c__size)
    {
      __b2c__sbuffer_length[__b2c__sbuffer_ptr] = (long) __b2c__size *4;
      return (realloc (__b2c__ptr, __b2c__size * 4));
    }
  return (__b2c__ptr);
}

char *
__b2c__strdup (const char *__b2c__s)
{
  if (__b2c__s == NULL)
    return (NULL);
  return (strdup (__b2c__s));
}

int
__b2c__strcmp (const char *__b2c__s1, const char *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    return 0;
  if (__b2c__s1 == NULL)
    return (-1);
  if (__b2c__s2 == NULL)
    return (1);
  return (strcmp (__b2c__s1, __b2c__s2));
}

int
__b2c__strcasecmp (const char *__b2c__s1, const char *__b2c__s2)
{
  if (__b2c__s1 == NULL && __b2c__s2 == NULL)
    return 0;
  if (__b2c__s1 == NULL)
    return (-1);
  if (__b2c__s2 == NULL)
    return (1);
  return (strcasecmp (__b2c__s1, __b2c__s2));
}

/* Functions for sort */
int
__b2c__sortnrd (const void *__b2c__a, const void *__b2c__b)
{
  if (*(double *) __b2c__a == *(double *) __b2c__b)
    return 0;
  else if (*(double *) __b2c__a < *(double *) __b2c__b)
    return -1;
  else
    return 1;
}

int
__b2c__sortnrd_down (const void *__b2c__a, const void *__b2c__b)
{
  if (*(double *) __b2c__a == *(double *) __b2c__b)
    return 0;
  else if (*(double *) __b2c__a < *(double *) __b2c__b)
    return 1;
  else
    return -1;
}

int
__b2c__sortnrf (const void *__b2c__a, const void *__b2c__b)
{
  if (*(float *) __b2c__a == *(float *) __b2c__b)
    return 0;
  else if (*(float *) __b2c__a < *(float *) __b2c__b)
    return -1;
  else
    return 1;
}

int
__b2c__sortnrf_down (const void *__b2c__a, const void *__b2c__b)
{
  if (*(float *) __b2c__a == *(float *) __b2c__b)
    return 0;
  else if (*(float *) __b2c__a < *(float *) __b2c__b)
    return 1;
  else
    return -1;
}

int
__b2c__sortnrl (const void *__b2c__a, const void *__b2c__b)
{
  if (*(long *) __b2c__a == *(long *) __b2c__b)
    return 0;
  else if (*(long *) __b2c__a < *(long *) __b2c__b)
    return -1;
  else
    return 1;
}

int
__b2c__sortnrl_down (const void *__b2c__a, const void *__b2c__b)
{
  if (*(long *) __b2c__a == *(long *) __b2c__b)
    return 0;
  else if (*(long *) __b2c__a < *(long *) __b2c__b)
    return 1;
  else
    return -1;
}

int
__b2c__sortnri (const void *__b2c__a, const void *__b2c__b)
{
  if (*(int *) __b2c__a == *(int *) __b2c__b)
    return 0;
  else if (*(int *) __b2c__a < *(int *) __b2c__b)
    return -1;
  else
    return 1;
}

int
__b2c__sortnri_down (const void *__b2c__a, const void *__b2c__b)
{
  if (*(int *) __b2c__a == *(int *) __b2c__b)
    return 0;
  else if (*(int *) __b2c__a < *(int *) __b2c__b)
    return 1;
  else
    return -1;
}

int
__b2c__sortstr (const void *__b2c__a, const void *__b2c__b)
{
  if (*(char **) __b2c__a == NULL)
    return -1;
  if (*(char **) __b2c__b == NULL)
    return 1;
  return strcmp (*(char **) __b2c__a, *(char **) __b2c__b);
}

int
__b2c__sortstr_down (const void *__b2c__a, const void *__b2c__b)
{
  if (*(char **) __b2c__a == NULL)
    return -1;
  if (*(char **) __b2c__b == NULL)
    return 1;
  return strcmp (*(char **) __b2c__b, *(char **) __b2c__a);
}

/* Actual functions */
int
__b2c__remove (const char *__b2c__path, const struct stat *__b2c__sb,
	       int __b2c__flag)
{
  __b2c__del_ctr++;
  __b2c__deltree = realloc (__b2c__deltree, __b2c__del_ctr * sizeof (char *));
  __b2c__deltree[__b2c__del_ctr - 1] = strdup (__b2c__path);
  return (0);
}

int
__b2c__rmrecursive (char *__b2c__path)
{
  int __b2c__result = 0;
  __b2c__result = ftw (__b2c__path, __b2c__remove, FOPEN_MAX);
  qsort (&__b2c__deltree[0], __b2c__del_ctr, sizeof (char *), __b2c__sortstr);
  while (__b2c__del_ctr > 0)
    {
      __b2c__del_ctr--;
      if (!__b2c__result)
	__b2c__result = remove (__b2c__deltree[__b2c__del_ctr]);
      free (__b2c__deltree[__b2c__del_ctr]);
    }
  free (__b2c__deltree);
  __b2c__deltree = NULL;
  return (__b2c__result);
}

char *
__b2c__curdir (void)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     512 * sizeof (char));
  return (char *) (getcwd (__b2c__sbuffer[__b2c__sbuffer_ptr], 512));
}

#define CURDIR__b2c__string_var __b2c__curdir()
char *
__b2c__reverse (char *__b2c__src)
{
  long __b2c__i, __b2c__l;
  if (__b2c__src == NULL)
    return ("");
  __b2c__l = strlen (__b2c__src);
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     (__b2c__l + 2) * sizeof (char));
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, __b2c__l + 1);
  for (__b2c__i = 0; __b2c__i < __b2c__l; __b2c__i++)
    {
      __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__i] =
	__b2c__src[__b2c__l - 1 - __b2c__i];
    }
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define REVERSE__b2c__string_var(__b2c__x) __b2c__reverse(__b2c__x)
char *
__b2c__str (double __b2c__d)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     32 * sizeof (char));
  if (floor (__b2c__d) == __b2c__d)
    snprintf (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%ld", (long) __b2c__d);
  else
    snprintf (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%g",
	      (double) __b2c__d);
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define STR__b2c__string_var(__b2c__x) __b2c__str(__b2c__x)
char *
__b2c__concat (char *__b2c__first, ...)
{
  long __b2c__len, __b2c__new;
  char *__b2c__next;
  va_list __b2c__ap;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  if (__b2c__first != NULL && (__b2c__len = strlen (__b2c__first)) > 0)
    {
      __b2c__sbuffer[__b2c__sbuffer_ptr] =
	(char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
				 __b2c__len * sizeof (char));
      memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr], __b2c__first,
	      __b2c__len * sizeof (char));
    }
  else
    {
      __b2c__len = 0;
      __b2c__sbuffer[__b2c__sbuffer_ptr] =
	(char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
				 sizeof (char));
    }
  va_start (__b2c__ap, __b2c__first);
  while ((__b2c__next = va_arg (__b2c__ap, char *)) != NULL)
    {
      __b2c__new = strlen (__b2c__next);
      __b2c__sbuffer[__b2c__sbuffer_ptr] =
	(char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
				 (__b2c__len + __b2c__new +
				  1) * sizeof (char));
      memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] + __b2c__len * sizeof (char),
	      __b2c__next, __b2c__new * sizeof (char));
      __b2c__len += __b2c__new;
    } va_end (__b2c__ap);
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__len] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define CONCAT__b2c__string_var(...) __b2c__concat(__VA_ARGS__, (char*)NULL)
char *
__b2c__left (char *__b2c__src, long __b2c__n)
{
  long __b2c__l;
  if (__b2c__src != NULL)
    __b2c__l = strlen (__b2c__src);
  if (__b2c__src == NULL || __b2c__n > __b2c__l || __b2c__n < 0)
    return (__b2c__src);
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     (__b2c__l + 1) * sizeof (char));
  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr], __b2c__src,
	  __b2c__n * sizeof (char));
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__n] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define LEFT__b2c__string_var(__b2c__x, __b2c__y) __b2c__left(__b2c__x, __b2c__y)
char *
__b2c__right (char *__b2c__src, long __b2c__n)
{
  long __b2c__l;
  if (__b2c__src != NULL)
    __b2c__l = strlen (__b2c__src);
  if (__b2c__src == NULL || __b2c__n > __b2c__l || __b2c__n < 0)
    return (__b2c__src);
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     (__b2c__l + 1) * sizeof (char));
  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr],
	  __b2c__src + (__b2c__l - __b2c__n) * sizeof (char),
	  __b2c__n * sizeof (char));
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__n] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define RIGHT__b2c__string_var(__b2c__x, __b2c__y) __b2c__right(__b2c__x, __b2c__y)
char *
__b2c__mid (char *__b2c__src, ...)
{
  va_list __b2c__ap;
  long __b2c__start, __b2c__len, __b2c__l;
  if (__b2c__src == NULL)
    return ("");
  va_start (__b2c__ap, __b2c__src);
  __b2c__start = va_arg (__b2c__ap, long);
  if (__b2c__start < 1)
    return (__b2c__src);
  __b2c__l = strlen (__b2c__src);
  if (__b2c__start > __b2c__l)
    return ("");
  __b2c__len = va_arg (__b2c__ap, long);
  if (__b2c__len < 0 || __b2c__start + __b2c__len > __b2c__l)
    __b2c__len = __b2c__l - __b2c__start + 1;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     (__b2c__len + 1) * sizeof (char));
  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr],
	  __b2c__src + (__b2c__start - 1) * sizeof (char),
	  __b2c__len * sizeof (char));
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__len] = '\0';
  va_end (__b2c__ap);
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define MID__b2c__string_var(__b2c__string, ...) __b2c__mid(__b2c__string, __VA_ARGS__, -1)
long
__b2c__instr (char *__b2c__first, ...)
{
  char *__b2c__tmp, *__b2c__res;
  int __b2c__pos;
  va_list __b2c__ap;
  if (__b2c__first == NULL)
    return (0);
  va_start (__b2c__ap, __b2c__first);
  __b2c__tmp = va_arg (__b2c__ap, char *);
  if (__b2c__tmp == NULL)
    return (0);
  __b2c__pos = va_arg (__b2c__ap, int);
  if (__b2c__pos <= 0)
    __b2c__pos = 1;
  va_end (__b2c__ap);
  __b2c__res = strstr (__b2c__first + __b2c__pos - 1, __b2c__tmp);
  if (__b2c__res == NULL)
    return (0);
  return (long) (__b2c__res - __b2c__first + 1);
}

#define INSTR(...) __b2c__instr(__VA_ARGS__, -1)
long
__b2c__instrrev (char *__b2c__first, ...)
{
  char *__b2c__tmp, *__b2c__res = NULL, *__b2c__found = NULL;
  long __b2c__pos, __b2c__l;
  va_list __b2c__ap;
  if (__b2c__first == NULL)
    return (0);
  va_start (__b2c__ap, __b2c__first);
  __b2c__tmp = va_arg (__b2c__ap, char *);
  if (__b2c__tmp == NULL)
    return (0);
  __b2c__pos = va_arg (__b2c__ap, int);
  if (__b2c__pos < 0)
    __b2c__pos = 0;
  va_end (__b2c__ap);
  __b2c__l = strlen (__b2c__first);
  __b2c__found = __b2c__first;
  do
    {
      __b2c__res = strstr (__b2c__found, __b2c__tmp);
      if (__b2c__res != NULL
	  && __b2c__res <= __b2c__first + __b2c__l - __b2c__pos)
	{
	  __b2c__found = __b2c__res + 1;
	  continue;
	}
      if (__b2c__res > __b2c__first + __b2c__l - __b2c__pos)
	__b2c__res = NULL;
    }
  while (__b2c__res != NULL);
  if (__b2c__option_startpoint)
    {
      if (__b2c__l - (__b2c__found - __b2c__first) + 1 > __b2c__l)
	return 0;
      return (long) (__b2c__l - (__b2c__found - __b2c__first) + 1);
    }
  return (long) (__b2c__found - __b2c__first);
}

#define INSTRREV(...) __b2c__instrrev(__VA_ARGS__, -1)
char *
__b2c__spc (int __b2c__x)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     __b2c__x * sizeof (char) + 1 * sizeof (char));
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, __b2c__x);
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__x] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define SPC__b2c__string_var(__b2c__x) ((__b2c__x) >= 0 ? __b2c__spc(__b2c__x) : "")
char *
__b2c__tab (int __b2c__x)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     __b2c__x * sizeof (char) + 1 * sizeof (char));
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 9, __b2c__x);
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__x] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define TAB__b2c__string_var(__b2c__x) ((__b2c__x) >= 0 ? __b2c__tab(__b2c__x) : "")
char *
__b2c__fill (unsigned long __b2c__x, unsigned char __b2c__y)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     __b2c__x * sizeof (char) + 1 * sizeof (char));
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], __b2c__y, __b2c__x);
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__x] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define FILL__b2c__string_var(__b2c__x, __b2c__y) ((__b2c__y) >= 0 && (__b2c__y) < 256 ? __b2c__fill(__b2c__x, __b2c__y) : "")
long
__b2c__count (char *__b2c_x, unsigned char __b2c_y)
{
  int __b2c_i, __b2c_z = 0;
  for (__b2c_i = 0; __b2c_i < strlen (__b2c_x); __b2c_i++)
    if (*(__b2c_x + __b2c_i) == __b2c_y)
      __b2c_z++;
  return __b2c_z;
}

#define COUNT(__b2c__x, __b2c__y) ((__b2c__x) != NULL ? __b2c__count(__b2c__x, __b2c__y) : 0)
char *
__b2c__chop (char *__b2c__src, ...)
{
  char *__b2c__tmp, *__b2c__str;
  long __b2c__i, __b2c__l, __b2c__loc = 0;
  va_list __b2c__ap;
  if (__b2c__src == NULL || strlen (__b2c__src) == 0)
    return (__b2c__src);
  va_start (__b2c__ap, __b2c__src);
  __b2c__str = va_arg (__b2c__ap, char *);
  if (__b2c__str == 0)
    __b2c__str = (char *) __b2c__chop_default;
  else
    __b2c__loc = va_arg (__b2c__ap, int);
  va_end (__b2c__ap);
  __b2c__l = strlen (__b2c__str);
  if (__b2c__loc == 0 || __b2c__loc == 1)
    {
      while (*__b2c__src != '\0')
	{
	  for (__b2c__i = 0; __b2c__i < __b2c__l; __b2c__i++)
	    {
	      if (*__b2c__src == *(__b2c__str + __b2c__i))
		{
		  __b2c__src++;
		  break;
		}
	    }
	  if (__b2c__i == __b2c__l)
	    break;
	}
      if (*__b2c__src == '\0')
	return ("");
    }
  __b2c__tmp = __b2c__src + strlen (__b2c__src) - 1;
  if (__b2c__loc == 0 || __b2c__loc == 2)
    {
      while (__b2c__tmp >= __b2c__src && *__b2c__tmp != '\0')
	{
	  for (__b2c__i = 0; __b2c__i < __b2c__l; __b2c__i++)
	    {
	      if (*__b2c__tmp == *(__b2c__str + __b2c__i))
		{
		  __b2c__tmp--;
		  break;
		}
	    }
	  if (__b2c__i == __b2c__l)
	    break;
	}
    }
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     (strlen (__b2c__src) + 1) * sizeof (char));
  for (__b2c__i = 0; __b2c__i <= __b2c__tmp - __b2c__src; __b2c__i++)
    __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__i] = __b2c__src[__b2c__i];
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__i] = '\0';
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define CHOP__b2c__string_var(...) __b2c__chop(__VA_ARGS__, 0)
char *
__b2c__extract (int __b2c__ln, const char *__b2c__fl, ...)
{
  int __b2c__i, __b2c__j, __b2c__flag, __b2c__reti, __b2c__ere, __b2c__pos =
    0;
  char *__b2c__src, *__b2c__needle, *__b2c__tmp;
  regex_t __b2c__reg;
  char __b2c__buf[100];
  regmatch_t __b2c__where[1];
  va_list __b2c__ap;
  va_start (__b2c__ap, __b2c__fl);
  __b2c__src = va_arg (__b2c__ap, char *);
  __b2c__needle = va_arg (__b2c__ap, char *);
  __b2c__ere = va_arg (__b2c__ap, int);
  va_end (__b2c__ap);
  if (__b2c__src == NULL || __b2c__needle == NULL)
    return (char *) (__b2c__src);
  if (strlen (__b2c__src) == 0 || strlen (__b2c__needle) == 0)
    return (char *) (__b2c__src);
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     (strlen (__b2c__src) + 1) * sizeof (char));
  if (__b2c__ere > 0)
    {
      if (__b2c__option_compare == 0)
	__b2c__reti = regcomp (&__b2c__reg, __b2c__needle, REG_EXTENDED);
      else
	__b2c__reti =
	  regcomp (&__b2c__reg, __b2c__needle, REG_EXTENDED | REG_ICASE);
      if (!__b2c__trap && __b2c__reti)
	{
	  ERROR = 27;
	  regerror (__b2c__reti, &__b2c__reg, __b2c__buf,
		    sizeof (__b2c__buf));
	  fprintf (stderr, "%s\n", __b2c__buf);
	  RUNTIMEFERR (__b2c__ln, __b2c__fl, "EXTRACT$", ERROR);
	}
      while ((__b2c__reti =
	      regexec (&__b2c__reg, __b2c__src, 1, __b2c__where, 0)) == 0)
	{
	  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] +
		  __b2c__pos * sizeof (char), __b2c__src,
		  (size_t) __b2c__where[0].rm_so * sizeof (char));
	  __b2c__pos += __b2c__where[0].rm_so;
	  __b2c__src += (long) __b2c__where[0].rm_eo;
	} regfree (&__b2c__reg);
      memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] + __b2c__pos * sizeof (char),
	      __b2c__src, strlen (__b2c__src) * sizeof (char));
      __b2c__pos += strlen (__b2c__src);
    }
  else
    {
      while ((__b2c__tmp = strstr (__b2c__src, __b2c__needle)) != NULL)
	{
	  __b2c__sbuffer[__b2c__sbuffer_ptr] =
	    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
				     (__b2c__pos + (__b2c__tmp - __b2c__src) +
				      1) * sizeof (char));
	  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] +
		  __b2c__pos * sizeof (char), __b2c__src,
		  (size_t) (__b2c__tmp - __b2c__src) * sizeof (char));
	  __b2c__pos += __b2c__tmp - __b2c__src;
	  __b2c__src = __b2c__tmp + strlen (__b2c__needle) * sizeof (char);
	} __b2c__sbuffer[__b2c__sbuffer_ptr] =
	(char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
				 (__b2c__pos + strlen (__b2c__src) +
				  1) * sizeof (char));
      memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] + __b2c__pos * sizeof (char),
	      __b2c__src, strlen (__b2c__src) * sizeof (char));
      __b2c__pos += strlen (__b2c__src);
    }
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__pos] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define EXTRACT__b2c__string_var(...) __b2c__extract(__LINE__, __FILE__, __VA_ARGS__, -1)
char *
__b2c__replace (int __b2c__ln, const char *__b2c__fl, ...)
{
  char *__b2c__tmp, *__b2c__haystack, *__b2c__needle, *__b2c__replace;
  long __b2c__rep, __b2c__hst, __b2c__ndl, __b2c__len = 0;
  regex_t __b2c__reg;
  int __b2c__reti, __b2c__flag;
  char __b2c__buf[100];
  regmatch_t __b2c__where[1];
  va_list __b2c__ap;
  va_start (__b2c__ap, __b2c__fl);
  __b2c__haystack = va_arg (__b2c__ap, char *);
  __b2c__needle = va_arg (__b2c__ap, char *);
  __b2c__replace = va_arg (__b2c__ap, char *);
  __b2c__flag = va_arg (__b2c__ap, int);
  va_end (__b2c__ap);
  if (__b2c__haystack == NULL || __b2c__needle == NULL
      || __b2c__replace == NULL)
    return (char *) (__b2c__haystack);
  __b2c__ndl = strlen (__b2c__needle);
  if (strlen (__b2c__haystack) == 0 || __b2c__ndl == 0)
    return (char *) (__b2c__haystack);
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     sizeof (char));
  *__b2c__sbuffer[__b2c__sbuffer_ptr] = '\0';
  __b2c__rep = strlen (__b2c__replace);
  if (__b2c__flag > 0)
    {
      if (__b2c__option_compare == 0)
	__b2c__reti = regcomp (&__b2c__reg, __b2c__needle, REG_EXTENDED);
      else
	__b2c__reti =
	  regcomp (&__b2c__reg, __b2c__needle, REG_EXTENDED | REG_ICASE);
      if (!__b2c__trap && __b2c__reti)
	{
	  ERROR = 27;
	  regerror (__b2c__reti, &__b2c__reg, __b2c__buf,
		    sizeof (__b2c__buf));
	  fprintf (stderr, "%s\n", __b2c__buf);
	  RUNTIMEFERR (__b2c__ln, __b2c__fl, "REPLACE$", ERROR);
	}
      while ((__b2c__reti =
	      regexec (&__b2c__reg, __b2c__haystack, 1, __b2c__where,
		       0)) == 0)
	{
	  __b2c__sbuffer[__b2c__sbuffer_ptr] =
	    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
				     (__b2c__len + __b2c__where[0].rm_so +
				      __b2c__rep + 1) * sizeof (char));
	  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] +
		  __b2c__len * sizeof (char), __b2c__haystack,
		  (size_t) __b2c__where[0].rm_so * sizeof (char));
	  __b2c__len += __b2c__where[0].rm_so;
	  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] +
		  __b2c__len * sizeof (char), __b2c__replace,
		  __b2c__rep * sizeof (char));
	  __b2c__len += __b2c__rep;
	  __b2c__haystack += (long) __b2c__where[0].rm_eo;
	} regfree (&__b2c__reg);
    }
  else
    {
      while ((__b2c__tmp = strstr (__b2c__haystack, __b2c__needle)) != NULL)
	{
	  __b2c__sbuffer[__b2c__sbuffer_ptr] =
	    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
				     (__b2c__len +
				      (__b2c__tmp - __b2c__haystack) +
				      __b2c__rep + 1) * sizeof (char));
	  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] +
		  __b2c__len * sizeof (char), __b2c__haystack,
		  (size_t) (__b2c__tmp - __b2c__haystack) * sizeof (char));
	  __b2c__len += __b2c__tmp - __b2c__haystack;
	  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] +
		  __b2c__len * sizeof (char), __b2c__replace,
		  __b2c__rep * sizeof (char));
	  __b2c__len += __b2c__rep;
	  __b2c__haystack = __b2c__tmp + __b2c__ndl;
    }} __b2c__hst = strlen (__b2c__haystack);
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     (__b2c__len + __b2c__hst + 1) * sizeof (char));
  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] + __b2c__len * sizeof (char),
	  __b2c__haystack, __b2c__hst * sizeof (char));
  __b2c__len += __b2c__hst;
  __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__len] = '\0';
  return (char *) (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define REPLACE__b2c__string_var(...) __b2c__replace(__LINE__, __FILE__, __VA_ARGS__, -1)
#define LEN(__b2c__x) ((__b2c__x) != NULL ? strlen(__b2c__x) : 0)
#define EQUAL(__b2c__x, __b2c__y) ((__b2c__x) != NULL && (__b2c__y) != NULL && __b2c__option_compare == 0 ? !strcmp(__b2c__x, __b2c__y) : ((__b2c__x) != NULL && (__b2c__y) != NULL && __b2c__option_compare == 1 ? !strcasecmp(__b2c__x, __b2c__y) : 0) )
char *
__b2c__getenv (char *__b2c__env)
{
  char *__b2c__tmp;
  __b2c__tmp = getenv (__b2c__env);
  if (__b2c__tmp == NULL)
    {
      return "";
    }
  return __b2c__tmp;
}

#define GETENVIRON__b2c__string_var(__b2c__x) ((__b2c__x) != NULL ? __b2c__getenv(__b2c__x) : "null")
#define SETENVIRON(__b2c__x, __b2c__y) if((__b2c__x) != NULL && (__b2c__y) != NULL) setenv(__b2c__x, __b2c__y, 1)

/* CHAR functions */
#include <ctype.h>
char *
__b2c__ucase (char *__b2c__s)
{
  int __b2c__i;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     strlen (__b2c__s) * sizeof (char) +
			     1 * sizeof (char));
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0,
	  strlen (__b2c__s) * sizeof (char) + 1 * sizeof (char));
  for (__b2c__i = 0; __b2c__i < strlen (__b2c__s); __b2c__i++)
    {
      __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__i] =
	toupper (__b2c__s[__b2c__i]);
    }
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define UCASE__b2c__string_var(__b2c__x) ((__b2c__x) != NULL ? __b2c__ucase(__b2c__x) : "null")
char *
__b2c__lcase (char *__b2c__s)
{
  int __b2c__i;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     strlen (__b2c__s) * sizeof (char) +
			     1 * sizeof (char));
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0,
	  strlen (__b2c__s) * sizeof (char) + 1 * sizeof (char));
  for (__b2c__i = 0; __b2c__i < strlen (__b2c__s); __b2c__i++)
    {
      __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__i] =
	tolower (__b2c__s[__b2c__i]);
    }
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define LCASE__b2c__string_var(__b2c__x) ((__b2c__x) != NULL ? __b2c__lcase(__b2c__x) : "null")

/* I/O functions */
FILE *__b2c__inFile;
FILE *__b2c__outFile;
int __b2c__Byte;
struct dirent *__b2c__dir;
char *
__b2c__dec2hex (int __b2c__i)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr], 32);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, 32);
  snprintf (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%X", __b2c__i);
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

long
__b2c__hex2dec (int __b2c__ln, const char *__b2c__fl, char *__b2c__h)
{
  unsigned int __b2c__i;
  if (sscanf (__b2c__h, "%X", &__b2c__i) == EOF && !__b2c__trap)
    {
      ERROR = 5;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "DEC", ERROR);
    }
  return (long) (__b2c__i);
}

char *
__b2c__asc2char (int __b2c__i)
{
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			     2 * sizeof (char));
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, 2 * sizeof (char));
  snprintf (__b2c__sbuffer[__b2c__sbuffer_ptr], 2, "%c", __b2c__i);
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

/* Function FILEEXISTS contributed by Armando Rivera */
long
__b2c__fileexists (const char *__b2c__x)
{
  struct stat __b2c__buf;
  if (stat (__b2c__x, &__b2c__buf) != -1)
    return 1;
  return 0;
}

#define FILEEXISTS(__b2c__x) __b2c__fileexists(__b2c__x)
long
__b2c__filelen (int __b2c__ln, const char *__b2c__fl, const char *__b2c__x)
{
  struct stat __b2c__buf;
  if (stat (__b2c__x, &__b2c__buf) < 0 && !__b2c__trap)
    {
      ERROR = 24;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "FILELEN", ERROR);
    }
  if (__b2c__x == NULL || stat (__b2c__x, &__b2c__buf) < 0)
    return -1;
  else
    return (long) (__b2c__buf.st_size);
}

#define FILELEN(__b2c__x) __b2c__filelen(__LINE__, __FILE__, __b2c__x)
long
__b2c__filetime (int __b2c__ln, const char *__b2c__fl, const char *__b2c__x,
		 int __b2c__y)
{
  struct stat __b2c__buf;
  if (stat (__b2c__x, &__b2c__buf) < 0 && !__b2c__trap)
    {
      ERROR = 24;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "FILETIME", ERROR);
    }
  if (__b2c__x == NULL || stat (__b2c__x, &__b2c__buf) < 0 || __b2c__y < 0
      || __b2c__y > 2)
    return -1;
  switch (__b2c__y)
    {
    case 0:
      return (long) (__b2c__buf.st_atime);
      break;
    case 1:
      return (long) (__b2c__buf.st_mtime);
      break;
    }
  return (long) (__b2c__buf.st_ctime);
}

#define FILETIME(__b2c__x, __b2c__y) __b2c__filetime(__LINE__, __FILE__, __b2c__x, __b2c__y)
long
__b2c__filetype (int __b2c__ln, const char *__b2c__fl, const char *__b2c__x)
{
  long __b2c_fs = 0;
  struct stat __b2c__buf;
  if (__b2c__x == NULL)
    return 0;
  if (lstat (__b2c__x, &__b2c__buf) < 0 && !__b2c__trap)
    {
      ERROR = 24;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "FILETYPE", ERROR);
    }
  if (S_ISREG (__b2c__buf.st_mode))
    __b2c_fs = 1;
  if (S_ISDIR (__b2c__buf.st_mode))
    __b2c_fs = 2;
  if (S_ISCHR (__b2c__buf.st_mode))
    __b2c_fs = 3;
  if (S_ISBLK (__b2c__buf.st_mode))
    __b2c_fs = 4;
  if (S_ISFIFO (__b2c__buf.st_mode))
    __b2c_fs = 5;
  if (S_ISLNK (__b2c__buf.st_mode))
    __b2c_fs = 6;
  if (S_ISSOCK (__b2c__buf.st_mode))
    __b2c_fs = 7;
  return __b2c_fs;
}

#define FILETYPE(__b2c__x) __b2c__filetype(__LINE__, __FILE__, __b2c__x)
long
__b2c__search (int __b2c__ln, const char *__b2c__fl, FILE * __b2c__x,
	       char *__b2c__y)
{
  long __b2c__off, __b2c__pos;
  char *__b2c__ptr;
  size_t __b2c__tot;
  if (__b2c__x == NULL && !__b2c__trap)
    {
      ERROR = 2;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "SEARCH", ERROR);
    }
  if (__b2c__y == NULL && !__b2c__trap)
    {
      ERROR = 25;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "SEARCH", ERROR);
    }
  __b2c__pos = ftell (__b2c__x);
  __b2c__ptr = (char *) malloc ((strlen (__b2c__y) + 1) * sizeof (char));
  __b2c__off = 0;
  do
    {
      fseek (__b2c__x, __b2c__off, SEEK_SET);
      memset (__b2c__ptr, 0, sizeof (char) * (strlen (__b2c__y) + 1));
      __b2c__tot =
	fread (__b2c__ptr, sizeof (char), strlen (__b2c__y), __b2c__x);
      __b2c__off += 1;
    }
  while (!feof (__b2c__x)
	 && strncmp (__b2c__ptr, __b2c__y, strlen (__b2c__y)));
  if (strncmp (__b2c__ptr, __b2c__y, strlen (__b2c__y)))
    __b2c__off = 0;
  fseek (__b2c__x, __b2c__pos, SEEK_SET);
  free (__b2c__ptr);
  return (--__b2c__off);
}

#define SEARCH(__b2c__x, __b2c__y) __b2c__search(__LINE__, __FILE__, __b2c__x, __b2c__y)
char *
__b2c__exec (int __b2c__ln, const char *__b2c__fl, char *__b2c__x, ...)
{
  int __b2c__r, __b2c__len, __b2c__i;
  int __b2c__wpipe[2], __b2c__rpipe[2];
  char *__b2c__str, *__b2c__ans = NULL;
  va_list __b2c__ap;
  va_start (__b2c__ap, __b2c__x);
  __b2c__str = va_arg (__b2c__ap, char *);
  va_end (__b2c__ap);
  if (pipe (__b2c__rpipe) < 0 || pipe (__b2c__wpipe) < 0)
    {
      if (!__b2c__trap)
	{
	  ERROR = 29;
	  RUNTIMEFERR (__b2c__ln, __b2c__fl, "EXEC$", ERROR);
	}
    }
  if ((__b2c__r = fork ()) < 0)
    {
      if (!__b2c__trap)
	{
	  ERROR = 29;
	  RUNTIMEFERR (__b2c__ln, __b2c__fl, "EXEC$", ERROR);
	}
    }
  else if (__b2c__r == 0)
    {
      close (__b2c__wpipe[1]);
      close (__b2c__rpipe[0]);
      dup2 (__b2c__wpipe[0], STDIN_FILENO);
      close (__b2c__wpipe[0]);
      dup2 (__b2c__rpipe[1], STDOUT_FILENO);
      close (__b2c__rpipe[1]);
      __b2c__r = system (__b2c__x);
      if (WIFEXITED (__b2c__r))
	__b2c__i = WEXITSTATUS (__b2c__r);
      else
	__b2c__i = 0;
      exit (__b2c__i);
    }
  else
    {
      close (__b2c__wpipe[0]);
      close (__b2c__rpipe[1]);
      __b2c__sbuffer_ptr++;
      if (__b2c__sbuffer_ptr >= 256)
	__b2c__sbuffer_ptr = 0;
      __b2c__sbuffer[__b2c__sbuffer_ptr] =
	__sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr], sizeof (char));
      __b2c__ans = (char *) malloc (512 * sizeof (char));
      __b2c__len = 0;
      if (__b2c__str != NULL)
	__b2c__i =
	  write (__b2c__wpipe[1], __b2c__str, strlen (__b2c__str) + 1);
      do
	{
	  __b2c__i = read (__b2c__rpipe[0], __b2c__ans, 512);
	  if (__b2c__i == -1 && !__b2c__trap)
	    {
	      ERROR = 30;
	      RUNTIMEFERR (__b2c__ln, __b2c__fl, "EXEC$", ERROR);
	    }
	  if (__b2c__i == 0)
	    break;
	  __b2c__sbuffer[__b2c__sbuffer_ptr] =
	    __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr],
			    (__b2c__len + __b2c__i + 1) * sizeof (char));
	  if (__b2c__sbuffer[__b2c__sbuffer_ptr] == NULL && !__b2c__trap)
	    {
	      ERROR = 6;
	      RUNTIMEFERR (__b2c__ln, __b2c__fl, "EXEC$", ERROR);
	    }
	  memcpy (__b2c__sbuffer[__b2c__sbuffer_ptr] +
		  __b2c__len * sizeof (char), __b2c__ans,
		  __b2c__i * sizeof (char));
	  __b2c__len += __b2c__i;
	}
      while (__b2c__i > 0);
      __b2c__sbuffer[__b2c__sbuffer_ptr][__b2c__len] = '\0';
      close (__b2c__wpipe[1]);
      close (__b2c__rpipe[0]);
      free (__b2c__ans);
      wait (&RETVAL);
      RETVAL = WEXITSTATUS (RETVAL);
    }
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define EXEC__b2c__string_var(...) __b2c__exec(__LINE__, __FILE__, __VA_ARGS__, (char*)NULL)
#define ENDFILE(__b2c__x) feof(__b2c__x)
#define TELL(__b2c__x) ftell(__b2c__x)
#define HEX__b2c__string_var(__b2c__x) __b2c__dec2hex(__b2c__x)
#define DEC(__b2c__x) __b2c__hex2dec(__LINE__, __FILE__, __b2c__x)
#define ASC(__b2c__x) (unsigned char) *__b2c__x
#define CHR__b2c__string_var(__b2c__x) __b2c__asc2char(__b2c__x)
#define MEMTELL(__b2c__x) (long)__b2c__x
#define ISKEY(__b2c_x, ...) ( (__b2c__ ## __b2c_x ## __add_secure(0, __VA_ARGS__, NULL) == NULL) ? 0 : 1)

/* Dynamic loading, errors */
#include <dlfcn.h>
#include <errno.h>

/* GETKEY */
#include <termios.h>
struct termios __b2c__tty;
long
__b2c__getch ()
{
  long __b2c__ch;
  struct termios __b2c__oldt, __b2c__newt;
  tcgetattr (STDIN_FILENO, &__b2c__oldt);
  __b2c__newt = __b2c__oldt;
  __b2c__newt.c_lflag &= ~(ICANON | ECHO);
  __b2c__newt.c_cc[VMIN] = 1;
  __b2c__newt.c_cc[VTIME] = 0;
  tcsetattr (STDIN_FILENO, TCSANOW, &__b2c__newt);
  __b2c__ch = getchar ();
  tcsetattr (STDIN_FILENO, TCSANOW, &__b2c__oldt);
  return __b2c__ch;
}

#define GETKEY __b2c__getch()
long
__b2c__getxy (int __b2c__type)
{
  char __b2c__asw[512];
  struct termios __b2c__old, __b2c__new;
  int __b2c__len, __b2c__x, __b2c__y;
  ssize_t __b2c__tot;
  tcgetattr (STDIN_FILENO, &__b2c__old);
  __b2c__new = __b2c__old;
  __b2c__new.c_lflag &= ~(ICANON | ECHO);
  tcsetattr (STDIN_FILENO, TCSANOW, &__b2c__new);
  __b2c__tot = write (STDOUT_FILENO, "\033[6n", strlen ("\033[6n"));
  __b2c__len = read (STDIN_FILENO, __b2c__asw, 512);
  __b2c__asw[__b2c__len] = '\0';
  tcsetattr (STDIN_FILENO, TCSANOW, &__b2c__old);
  sscanf (__b2c__asw, "\033[%d;%dR", &__b2c__y, &__b2c__x);
  if (!__b2c__type)
    return (long) __b2c__x;
  return (long) __b2c__y;
}

#define GETX __b2c__getxy(0)
#define GETY __b2c__getxy(1)
long
__b2c__screen (int __b2c__type)
{
  long __b2c__x;
  fprintf (stdout, "\033[s");
  fprintf (stdout, "\033[?25l");
  fprintf (stdout, "\033[999;999H");
  fflush (stdout);
  __b2c__x = __b2c__getxy (__b2c__type);
  fprintf (stdout, "\033[u");
  fprintf (stdout, "\033[?25h");
  fflush (stdout);
  return (__b2c__x);
}

#define COLUMNS __b2c__screen(0)
#define ROWS __b2c__screen(1)

/* Constants, logical stuff */
#define PI 3.1415926536
#define NOT(__b2c__x) (!(__b2c__x))
#define AND &&
#define OR ||
#define IS ==
#define NE !=
#define ISNOT !=
#define LT <
#define GT >
#define LE <=
#define GE >=
#define EQ ==
#undef TRUE
#define TRUE 1
#undef FALSE
#define FALSE 0
#define NL__b2c__string_var "\n"
#define STRING char*
#define NUMBER long
#define FLOATING double
#define ISTRUE(__b2c__x) ((__b2c__x) != 0)
#define ISFALSE(__b2c__x) ((__b2c__x) == 0)
#define SIZEOF(__b2c__x) sizeof(__b2c__x)

/* Date and time */
#include <time.h>
#define NOW (long)time(NULL)
long
__b2c__time (time_t __b2c__now, int __b2c__which)
{
  struct tm *__b2c__ts;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr], 32);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, 32);
  __b2c__ts = localtime (&__b2c__now);
  switch (__b2c__which)
    {
    case 1:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%d", __b2c__ts);
      break;
    case 2:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%m", __b2c__ts);
      break;
    case 3:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%Y", __b2c__ts);
      break;
    case 4:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%H", __b2c__ts);
      break;
    case 5:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%M", __b2c__ts);
      break;
    case 6:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%S", __b2c__ts);
      break;
    case 7:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%W", __b2c__ts);
      break;
    }
  return (atol (__b2c__sbuffer[__b2c__sbuffer_ptr]));
}

#define DAY(x) __b2c__time(x, 1)
#define MONTH(x) __b2c__time(x, 2)
#define YEAR(x) __b2c__time(x, 3)
#define HOUR(x) __b2c__time(x, 4)
#define MINUTE(x) __b2c__time(x, 5)
#define SECOND(x) __b2c__time(x, 6)
#define WEEK(x) __b2c__time(x, 7)
char *
__b2c__datename (time_t __b2c__now, int __b2c__which)
{
  struct tm *__b2c__ts;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr], 32);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, 32);
  __b2c__ts = localtime (&__b2c__now);
  switch (__b2c__which)
    {
    case 1:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%A", __b2c__ts);
      break;
    case 2:
      strftime (__b2c__sbuffer[__b2c__sbuffer_ptr], 32, "%B", __b2c__ts);
      break;
    }
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define WEEKDAY__b2c__string_var(x) __b2c__datename(x, 1)
#define MONTH__b2c__string_var(x) __b2c__datename(x, 2)
unsigned long
__b2c__epoch (int __b2c__year, int __b2c__month, int __b2c__day,
	      int __b2c__hour, int __b2c__minute, int __b2c__second)
{
  struct tm tm;
  time_t __b2c__t;
  tm.tm_year = __b2c__year - 1900;
  tm.tm_mon = __b2c__month - 1;
  tm.tm_mday = __b2c__day;
  tm.tm_hour = __b2c__hour;
  tm.tm_min = __b2c__minute;
  tm.tm_sec = __b2c__second;
  tm.tm_isdst = -1;
  __b2c__t = mktime (&tm);
  if (__b2c__t == -1)
    return (0);
  return (long) __b2c__t;
}

#define TIMEVALUE(x,y,z,a,b,c) __b2c__epoch(x,y,z,a,b,c)
unsigned long
__b2c__timer ()
{
  struct timeval __b2c__time;
  gettimeofday (&__b2c__time, NULL);
  if (difftime (__b2c__time.tv_sec, __b2c__elapsed_secs) < 1)
    return (unsigned long) ((__b2c__time.tv_usec - __b2c__elapsed_usecs) /
			    1000);
  else
    return (unsigned
	    long) ((difftime (__b2c__time.tv_sec, __b2c__elapsed_secs) -
		    1) * 1000 + ((1000000 - __b2c__elapsed_usecs) +
				 __b2c__time.tv_usec) / 1000);
}

#define TIMER __b2c__timer()
char *
__b2c__os (int __b2c__ln, const char *__b2c__fl)
{
  struct utsname __b2c__buf;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr], 512);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, 512);
  if (uname (&__b2c__buf) < 0 && !__b2c__trap)
    {
      ERROR = 26;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "OS$", ERROR);
    }
  strcpy (__b2c__sbuffer[__b2c__sbuffer_ptr], __b2c__buf.sysname);
  strcat (__b2c__sbuffer[__b2c__sbuffer_ptr], " ");
  strcat (__b2c__sbuffer[__b2c__sbuffer_ptr], __b2c__buf.machine);
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define OS__b2c__string_var __b2c__os(__LINE__, __FILE__)

/* Signal trapping activated with TRAP */
void
__b2c__catch_signal (int __b2c__sig)
{
  switch (__b2c__sig)
    {
    case SIGABRT:
      fprintf (stderr,
	       "ERROR: signal ABORT received - internal error. Try to compile the program with TRAP LOCAL to find the cause.\n");
      break;
    case SIGFPE:
      fprintf (stderr,
	       "ERROR: signal for FPE received - division by zero? Examine the calculations in the program.\n");
      break;
    case SIGSEGV:
      fprintf (stderr,
	       "ERROR: signal for SEGMENTATION FAULT received - memory invalid or array out of bounds? Try to compile the program with TRAP LOCAL to find the cause.\n");
      break;
    case SIGILL:
      fprintf (stderr,
	       "ERROR: signal for ILLEGAL INSTRUCTION received - executing the program on other hardware? Try to recompile the program from scratch.\n");
      break;
    }
  exit (__b2c__sig);
}

/* Peek and Poke */
void
__b2c__segv (int __b2c__sig)
{
  longjmp (__b2c__jump, 1);
}

int
__b2c__memory__check (void *__b2c__x, int __b2c__size)
{
  volatile char __b2c__c;
  int __b2c__i, __b2c__illegal = 0;
  signal (SIGSEGV, __b2c__segv);
  if (!setjmp (__b2c__jump))
    for (__b2c__i = 0; __b2c__i < __b2c__size; __b2c__i++)
      __b2c__c = *((char *) __b2c__x + __b2c__i);
  else
    __b2c__illegal = 1;
  if (__b2c__trap)
    signal (SIGSEGV, __b2c__catch_signal);
  else
    signal (SIGSEGV, SIG_DFL);
  return (__b2c__illegal);
}

#define MEMCHECK(__b2c__x) !(__b2c__memory__check((void*)__b2c__x, sizeof(__b2c__MEMTYPE)))
int
__b2c__memory_err (int __b2c__ln, const char *__b2c__fl)
{
  ERROR = 6;
  RUNTIMEFERR (__b2c__ln, __b2c__fl, "MEMORY", ERROR);
  return (0);
}

#define MEMORY(__b2c__x)( (__b2c__assign = calloc(__b2c__x+__b2c__option_memstream, sizeof(__b2c__MEMTYPE))) != NULL ? (long)__b2c__assign : __b2c__memory_err(__LINE__, __FILE__) )
int
__b2c__peek_check (int __b2c__ln, const char *__b2c__fl, void *__b2c__x,
		   int __b2c__size)
{
  if (!__b2c__trap)
    {
      if (__b2c__memory__check (__b2c__x, __b2c__size))
	{
	  ERROR = 1;
	  RUNTIMEFERR (__b2c__ln, __b2c__fl, "PEEK", ERROR);
	}
    }
  return (0);
}

#define PEEK(__b2c__x) (__b2c__peek_check(__LINE__, __FILE__, (void*)__b2c__x, sizeof(__b2c__MEMTYPE)) == 0 ? *(__b2c__MEMTYPE *)(__b2c__x) : 0)
#define ADDRESS(__b2c__x) (long)(&__b2c__x)
#define FP(__b2c__x) (void*)(&__b2c__x)

/* Network variables and functions */
struct timeval __b2c__to;
struct hostent *__b2c__he;
char *__b2c__host;
char *__b2c__port;
int __b2c__yes = 1;
char __b2c__ttl = 1;
struct sockaddr_in *__b2c__addr, *__b2c__from;
struct ip_mreq __b2c__imreq;
int __b2c__result;
char __b2c__data_client[512] = { 0 };
char __b2c__data_server[512] = { 0 };

int __b2c__handle;
long
__b2c__netpeek (int __b2c__ln, const char *__b2c__fl, int __b2c__fd,
		int __b2c__usec)
{
  fd_set __b2c__rfds;
  struct timeval __b2c__tv;
  long __b2c__retval;
  struct termios __b2c__oldt, __b2c__newt;
  if (__b2c__fd == STDIN_FILENO)
    {
      tcgetattr (STDIN_FILENO, &__b2c__oldt);
      __b2c__newt = __b2c__oldt;
      __b2c__newt.c_lflag &= ~(ICANON | ECHO);
      __b2c__newt.c_cc[VMIN] = 1;
      __b2c__newt.c_cc[VTIME] = 0;
      tcsetattr (STDIN_FILENO, TCSANOW, &__b2c__newt);
    }
  FD_ZERO (&__b2c__rfds);
  FD_SET (__b2c__fd, &__b2c__rfds);
  __b2c__tv.tv_usec = (__b2c__usec % 1000) * 1000;
  __b2c__tv.tv_sec = __b2c__usec / 1000;
  __b2c__retval =
    select (__b2c__fd + 1, &__b2c__rfds, NULL, NULL, &__b2c__tv);
  if (__b2c__retval == -1 && !__b2c__trap)
    {
      ERROR = 16;
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "WAIT", ERROR);
    }
  if (__b2c__fd == STDIN_FILENO)
    {
      if (__b2c__retval)
	if (read (__b2c__fd, &__b2c__retval, 1) == 0)
	  __b2c__retval = 0;
      tcsetattr (STDIN_FILENO, TCSANOW, &__b2c__oldt);
    }
  return (__b2c__retval);
}

#define WAIT(__b2c__x, __b2c__y) __b2c__netpeek(__LINE__, __FILE__, __b2c__x, __b2c__y)
char *
__b2c__nethost (int __b2c__ln, const char *__b2c__fl, char *__b2c__host)
{
  int __b2c__y;
  int __b2c__flag = 0;
  struct in_addr __b2c__address;
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr], 512);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, 512);
  for (__b2c__y = 0; __b2c__y < strlen (__b2c__host); __b2c__y++)
    {
      if (isalpha (*(__b2c__host + __b2c__y)))
	{
	  __b2c__flag = 1;
	  break;
	}
    }
  if (__b2c__flag)
    __b2c__he = gethostbyname (__b2c__host);
  else
    {
      if (inet_aton (__b2c__host, &__b2c__address))
	__b2c__he =
	  gethostbyaddr ((void *) &__b2c__address, sizeof (struct in_addr),
			 AF_INET);
  } if (__b2c__he == NULL || __b2c__he->h_addr == NULL
	  || __b2c__he->h_name == NULL)
    {
      if (!__b2c__trap)
	{
	  ERROR = 11;
	  RUNTIMEFERR (__b2c__ln, __b2c__fl, "HOST$", ERROR);
	}
      else
	strncpy (__b2c__sbuffer[__b2c__sbuffer_ptr], "Host not found",
		 512 - 1);
    }
  else
    {
      if (__b2c__flag)
	{
	  __b2c__addr = calloc (1, sizeof (*__b2c__addr));
	  __b2c__addr->sin_addr = *((struct in_addr *) __b2c__he->h_addr);
	  strncpy (__b2c__sbuffer[__b2c__sbuffer_ptr],
		   inet_ntoa (__b2c__addr->sin_addr), 512 - 1);
	  free (__b2c__addr);
	}
      else
	strncpy (__b2c__sbuffer[__b2c__sbuffer_ptr], __b2c__he->h_name,
		 512 - 1);
    }
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define HOST__b2c__string_var(__b2c__x) __b2c__nethost(__LINE__, __FILE__, __b2c__x)
char *
__b2c__getpeer (int __b2c__ln, const char *__b2c__fl, int __b2c__x)
{
  struct sockaddr_in *__b2c__peer;
  unsigned int __b2c__len = sizeof (__b2c__peer);
  char __b2c__port[6];
  __b2c__sbuffer_ptr++;
  if (__b2c__sbuffer_ptr >= 256)
    __b2c__sbuffer_ptr = 0;
  __b2c__sbuffer[__b2c__sbuffer_ptr] =
    (char *) __sbuf_realloc (__b2c__sbuffer[__b2c__sbuffer_ptr], 512);
  memset (__b2c__sbuffer[__b2c__sbuffer_ptr], 0, 512);
  __b2c__peer = calloc (1, sizeof (*__b2c__peer));
  if (getpeername (__b2c__x, (struct sockaddr *) __b2c__peer, &__b2c__len) <
      0)
    {
      if (!__b2c__trap)
	{
	  ERROR = 16;
	  RUNTIMEFERR (__b2c__ln, __b2c__fl, "GETPEER$", ERROR);
	}
      else
	strncpy (__b2c__sbuffer[__b2c__sbuffer_ptr], "Peer not found",
		 512 - 1);
    }
  else
    {
      strncpy (__b2c__sbuffer[__b2c__sbuffer_ptr],
	       inet_ntoa (__b2c__peer->sin_addr), 512 - 7);
      strcat (__b2c__sbuffer[__b2c__sbuffer_ptr], ":");
      snprintf (__b2c__port, 6, "%d", ntohs (__b2c__peer->sin_port));
      strcat (__b2c__sbuffer[__b2c__sbuffer_ptr], __b2c__port);
    }
  free (__b2c__peer);
  return (__b2c__sbuffer[__b2c__sbuffer_ptr]);
}

#define GETPEER__b2c__string_var(__b2c__x) __b2c__getpeer(__LINE__, __FILE__, __b2c__x)

/* Regex */
long
__b2c__regex (int __b2c__ln, const char *__b2c__fl, char *__b2c__x,
	      char *__b2c__y)
{
  regex_t __b2c__reg;
  int __b2c__reti;
  char __b2c__buf[100];
  regmatch_t __b2c__where[1];
  if (__b2c__option_compare == 0)
    __b2c__reti = regcomp (&__b2c__reg, __b2c__y, REG_EXTENDED);
  else
    __b2c__reti = regcomp (&__b2c__reg, __b2c__y, REG_EXTENDED | REG_ICASE);
  if (!__b2c__trap && __b2c__reti)
    {
      ERROR = 27;
      regerror (__b2c__reti, &__b2c__reg, __b2c__buf, sizeof (__b2c__buf));
      fprintf (stderr, "%s\n", __b2c__buf);
      RUNTIMEFERR (__b2c__ln, __b2c__fl, "REGEX", ERROR);
    }
  __b2c__reti = regexec (&__b2c__reg, __b2c__x, 1, __b2c__where, 0);
  regfree (&__b2c__reg);
  if (!__b2c__reti)
    {
      REGLEN = __b2c__where[0].rm_eo - __b2c__where[0].rm_so;
      return (__b2c__where[0].rm_so + 1);
    }
  else
    {
      REGLEN = 0;
      return (0);
    }
}

#define REGEX(__b2c__x, __b2c__y) __b2c__regex(__LINE__, __FILE__, __b2c__x, __b2c__y)

/* Declare reserved variable 'ARGUMENT' */
int __b2c__counter;
int __b2c__arglen = 0;
char *ARGUMENT__b2c__string_var;

/* Initialize stack arrays and pointer */
char **__b2c__stringstack = NULL;
double *__b2c__doublestack = NULL;
long *__b2c__longstack = NULL;
int *__b2c__typestack = NULL;
int __b2c__stackptr = 0;
int
__b2c__makedir (char *__b2c__in)
{
  char *__b2c__i, *__b2c__dir;
  if (__b2c__in == NULL || strlen (__b2c__in) == 0)
    return 0;
  if (*__b2c__in != '/')
    {
      __b2c__dir = calloc (strlen (__b2c__in) + 3, sizeof (char));
      strncpy (__b2c__dir, "./", 2);
      __b2c__dir = strcat (__b2c__dir, __b2c__in);
    }
  else
    __b2c__dir = __b2c__strdup (__b2c__in);
  __b2c__i = __b2c__dir;
  do
    {
      __b2c__i++;
      while (*__b2c__i != '/' && *__b2c__i != '\0')
	__b2c__i++;
      if (*__b2c__i == '/')
	{
	  *__b2c__i = '\0';
	  mkdir (__b2c__dir, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
	  *__b2c__i = '/';
	}
      else if (*__b2c__i == '\0')
	mkdir (__b2c__dir, S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
      if (errno != EEXIST && errno != 0)
	{
	  free (__b2c__dir);
	  return errno;
	}
    }
  while (*__b2c__i != '\0');
  free (__b2c__dir);
  return 0;
}

/* Initialize error function */
char *
ERR__b2c__string_var (int __b2c__nr)
{
  static char __b2c__warn[512] = { 0 };
  const char *__b2c__err;
  switch (__b2c__nr)
    {
    case 0:
      strcpy (__b2c__warn, "Success");
      break;
    case 1:
      strcpy (__b2c__warn, "Trying to access illegal memory: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 2:
      strcpy (__b2c__warn, "Error opening file: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 3:
      strcpy (__b2c__warn, "Could not open library ");
      __b2c__err = dlerror ();
      if (__b2c__err != NULL)
	strncat (__b2c__warn, __b2c__err, 512 - 48);
      break;
    case 4:
      strcpy (__b2c__warn, "Symbol not found in library ");
      __b2c__err = dlerror ();
      if (__b2c__err != NULL)
	strncat (__b2c__warn, __b2c__err, 512 - 48);
      break;
    case 5:
      strcpy (__b2c__warn, "Wrong hexvalue: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 6:
      strcpy (__b2c__warn, "Unable to claim memory.");
      break;
    case 7:
      strcpy (__b2c__warn, "Unable to delete file: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 8:
      strcpy (__b2c__warn, "Could not open directory: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 9:
      strcpy (__b2c__warn, "Unable to rename file: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 10:
      strcpy (__b2c__warn,
	      "NETWORK argument should contain colon with port number");
      break;
    case 11:
      strcpy (__b2c__warn, "Could not resolve hostname!");
      break;
    case 12:
      strcpy (__b2c__warn, "Socket error: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 13:
      strcpy (__b2c__warn, "Unable to open address: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 14:
      strcpy (__b2c__warn, "Error reading from socket: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 15:
      strcpy (__b2c__warn, "Error sending to socket: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 16:
      strcpy (__b2c__warn, "Error checking socket: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 17:
      strcpy (__b2c__warn, "Unable to bind the specified socket address: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 18:
      strcpy (__b2c__warn, "Unable to listen to socket address: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 19:
      strcpy (__b2c__warn, "Cannot accept incoming connection: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 20:
      strcpy (__b2c__warn, "Unable to remove directory: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 21:
      strcpy (__b2c__warn, "Unable to create directory: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 22:
      strcpy (__b2c__warn, "Unable to change to directory: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 23:
      strcpy (__b2c__warn,
	      "GETENVIRON argument does not exist as environment variable");
      break;
    case 24:
      strcpy (__b2c__warn, "Unable to stat file: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 25:
      strcpy (__b2c__warn, "Search contains illegal string");
      break;
    case 26:
      strcpy (__b2c__warn, "Cannot return OS name: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 27:
      strcpy (__b2c__warn, "Illegal regex expression");
      break;
    case 28:
      strcpy (__b2c__warn, "Unable to create bidirectional pipes: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 29:
      strcpy (__b2c__warn, "Unable to fork process: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 30:
      strcpy (__b2c__warn, "Cannot read from pipe: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 31:
      strcpy (__b2c__warn, "Gosub nesting too deep!");
      break;
    case 32:
      strcpy (__b2c__warn, "Could not open device: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 33:
      strcpy (__b2c__warn, "Error configuring serial port: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 34:
      strcpy (__b2c__warn, "Error accessing device: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    case 35:
      strcpy (__b2c__warn, "Error in INPUT: ");
      strncat (__b2c__warn, strerror (errno), 512 - 48);
      break;
    };
  ERROR = 0;
  return (__b2c__warn);
}

#define COMPILED_BY_WHICH_BACON__b2c__string_var "BASH BaCon 2.4.0"
